#include <algorithm>
#include "fronius_device_info.h"

static FroniusDeviceInfo Devices[] =
{
	{  71, 3, false, "FRONIUS Symo 15.0-3 208" },
	{  72, 3, false, "FRONIUS Eco 27.0-3-S" },
	{  73, 3, false, "FRONIUS Eco 25.0-3-S" },
	{  74, 1, false, "Remote Plant" },
	{  75, 1, false, "Fronius Primo 6.0-1" },
	{  76, 1, false, "Fronius Primo 5.0-1" },
	{  77, 1, false, "Fronius Primo 4.6-1" },
	{  78, 1, false, "Fronius Primo 4.0-1" },
	{  79, 1, false, "Fronius Primo 3.6-1" },
	{  80, 1, false, "Fronius Primo 3.5-1" },
	{  81, 1, false, "Fronius Primo 3.0-1" },
	{  82, 3, false, "Fronius Symo Hybrid 4.0-3-S" },
	{  83, 3, false, "Fronius Symo Hybrid 3.0-3-S" },
	{  84, 1, false, "Fronius IG Plus 120 V-1" },
	{  85, 1, false, "Fronius Primo 3.8-1 208-240" },
	{  86, 1, false, "Fronius Primo 5.0-1 208-240" },
	{  87, 1, false, "Fronius Primo 6.0-1 208-240" },
	{  88, 1, false, "Fronius Primo 7.6-1 208-240" },
	{  89, 3,  true, "Fronius Symo 24.0-3 USA Dummy" },
	{  90, 3,  true, "Fronius Symo 24.0-3 480" },
	{  91, 3,  true, "Fronius Symo 22.7-3 480" },
	{  92, 3,  true, "Fronius Symo 20.0-3 480" },
	{  93, 3,  true, "Fronius Symo 17.5-3 480" },
	{  94, 3,  true, "Fronius Symo 15.0-3 480" },
	{  95, 3,  true, "Fronius Symo 12.5-3 480" },
	{  96, 3,  true, "Fronius Symo 10.0-3 480" },
	{  97, 3,  true, "Fronius Symo 12.0-3 208-240" },
	{  98, 3,  true, "Fronius Symo 10.0-3 208-240" },
	{  99, 3, false, "Fronius Symo Hybrid 5.0-3-S" },
	{ 100, 1, false, "Fronius Primo 8.2-1 Dummy" },
	{ 101, 1, false, "Fronius Primo 8.2-1 208-240" },
	{ 102, 1, false, "Fronius Primo 8.2-1" },
	{ 103, 3, false, "Fronius Agilo TL 360.0-3" },
	{ 104, 3, false, "Fronius Agilo TL 460.0-3" },
	{ 105, 3,  true, "Fronius Symo 7.0-3-M" },
	{ 106, 1, false, "Fronius Galvo 3.1-1 208-240" },
	{ 107, 1, false, "Fronius Galvo 2.5-1 208-240" },
	{ 108, 1, false, "Fronius Galvo 2.0-1 208-240" },
	{ 109, 1, false, "Fronius Galvo 1.5-1 208-240" },
	{ 110, 3,  true, "Fronius Symo 6.0-3-M" },
	{ 111, 3,  true, "Fronius Symo 4.5-3-M" },
	{ 112, 3,  true, "Fronius Symo 3.7-3-M" },
	{ 113, 3,  true, "Fronius Symo 3.0-3-M" },
	{ 114, 3,  true, "Fronius Symo 17.5-3-M" },
	{ 115, 3,  true, "Fronius Symo 15.0-3-M" },
	{ 116, 3, false, "Fronius Agilo 75.0-3 Outdoor" },
	{ 117, 3, false, "Fronius Agilo 100.0-3 Outdoor" },
	{ 118, 1, false, "Fronius IG Plus 55 V-1" },
	{ 119, 2, false, "Fronius IG Plus 55 V-2" },
	{ 120, 3,  true, "Fronius Symo 20.0-3 Dummy" },
	{ 121, 3,  true, "Fronius Symo 20.0-3-M" },
	{ 122, 3,  true, "Fronius Symo 5.0-3-M" },
	{ 123, 3,  true, "Fronius Symo 8.2-3-M" },
	{ 124, 3,  true, "Fronius Symo 6.7-3-M" },
	{ 125, 3,  true, "Fronius Symo 5.5-3-M" },
	{ 126, 3, false, "Fronius Symo 4.5-3-S" },
	{ 127, 3, false, "Fronius Symo 3.7-3-S" },
	{ 128, 2, false, "Fronius IG Plus 60 V-2" },
	{ 129, 1, false, "Fronius IG Plus 60 V-1" },
	{ 130, 3, false, "SPR 8001F-3 EU" },
	{ 131, 1, false, "Fronius IG Plus 25 V-1" },
	{ 132, 3, false, "Fronius IG Plus 100 V-3" },
	{ 133, 3, false, "Fronius Agilo 100.0-3" },
	{ 134, 1, false, "SPR 3001F-1 EU" },
	{ 135, 3, false, "Fronius IG Plus V/A 10.0-3 Delta" },
	{ 136, 1, false, "Fronius IG 50" },
	{ 137, 1, false, "Fronius IG Plus 30 V-1" },
	{ 138, 1, false, "SPR-11401f-1 UNI" },
	{ 139, 3, false, "SPR-12001f-3 WYE277" },
	{ 140, 3, false, "SPR-11401f-3 Delta" },
	{ 141, 1, false, "SPR-10001f-1 UNI" },
	{ 142, 1, false, "SPR-7501f-1 UNI" },
	{ 143, 1, false, "SPR-6501f-1 UNI" },
	{ 144, 1, false, "SPR-3801f-1 UNI" },
	{ 145, 1, false, "SPR-3301f-1 UNI" },
	{ 146, 3, false, "SPR 12001F-3 EU" },
	{ 147, 3, false, "SPR 10001F-3 EU" },
	{ 148, 2, false, "SPR 8001F-2 EU" },
	{ 149, 2, false, "SPR 6501F-2 EU" },
	{ 150, 1, false, "SPR 4001F-1 EU" },
	{ 151, 1, false, "SPR 3501F-1 EU" },
	{ 152, 1, false, "Fronius CL 60.0 WYE277 Dummy" },
	{ 153, 1, false, "Fronius CL 55.5 Delta Dummy" },
	{ 154, 1, false, "Fronius CL 60.0 Dummy" },
	{ 155, 3, false, "Fronius IG Plus V 12.0-3 Dummy" },
	{ 156, 1, false, "Fronius IG Plus V 7.5-1 Dummy" },
	{ 157, 1, false, "Fronius IG Plus V 3.8-1 Dummy" },
	{ 158, 3, false, "Fronius IG Plus 150 V-3 Dummy" },
	{ 159, 2, false, "Fronius IG Plus 100 V-2 Dummy" },
	{ 160, 1, false, "Fronius IG Plus 50 V-1 Dummy" },
	{ 161, 3, false, "Fronius IG Plus V/A 12.0-3 WYE" },
	{ 162, 3, false, "Fronius IG Plus V/A 11.4-3 Delta" },
	{ 163, 1, false, "Fronius IG Plus V/A 11.4-1 UNI" },
	{ 164, 1, false, "Fronius IG Plus V/A 10.0-1 UNI" },
	{ 165, 1, false, "Fronius IG Plus V/A 7.5-1 UNI" },
	{ 166, 1, false, "Fronius IG Plus V/A 6.0-1 UNI" },
	{ 167, 1, false, "Fronius IG Plus V/A 5.0-1 UNI" },
	{ 168, 1, false, "Fronius IG Plus V/A 3.8-1 UNI" },
	{ 169, 1, false, "Fronius IG Plus V/A 3.0-1 UNI" },
	{ 170, 3, false, "Fronius IG Plus 150 V-3" },
	{ 171, 3, false, "Fronius IG Plus 120 V-3" },
	{ 172, 2, false, "Fronius IG Plus 100 V-2" },
	{ 173, 1, false, "Fronius IG Plus 100 V-1" },
	{ 174, 2, false, "Fronius IG Plus 70 V-2" },
	{ 175, 1, false, "Fronius IG Plus 70 V-1" },
	{ 176, 1, false, "Fronius IG Plus 50 V-1" },
	{ 177, 1, false, "Fronius IG Plus 35 V-1" },
	{ 178, 3, false, "SPR 11400f-3 208/240" },
	{ 179, 1, false, "SPR 12000f-277" },
	{ 180, 1, false, "SPR 10000f" },
	{ 181, 1, false, "SPR 10000F EU" },
	{ 182, 1, false, "Fronius CL 33.3 Delta" },
	{ 183, 1, false, "Fronius CL 44.4 Delta" },
	{ 184, 1, false, "Fronius CL 55.5 Delta" },
	{ 185, 1, false, "Fronius CL 36.0 WYE277" },
	{ 186, 1, false, "Fronius CL 48.0 WYE277" },
	{ 187, 1, false, "Fronius CL 60.0 WYE277" },
	{ 188, 1, false, "Fronius CL 36.0" },
	{ 189, 1, false, "Fronius CL 48.0" },
	{ 190, 1, false, "Fronius IG TL 3.0" },
	{ 191, 1, false, "Fronius IG TL 4.0" },
	{ 192, 1, false, "Fronius IG TL 5.0" },
	{ 193, 1, false, "Fronius IG TL 3.6" },
	{ 194, 1, false, "Fronius IG TL Dummy" },
	{ 195, 1, false, "Fronius IG TL 4.6" },
	{ 196, 1, false, "SPR 12000F EU" },
	{ 197, 1, false, "SPR 8000F EU" },
	{ 198, 1, false, "SPR 6500F EU" },
	{ 199, 1, false, "SPR 4000F EU" },
	{ 200, 1, false, "SPR 3300F EU" },
	{ 201, 1, false, "Fronius CL 60.0" },
	{ 202, 1, false, "SPR 12000f" },
	{ 203, 1, false, "SPR 8000f" },
	{ 204, 1, false, "SPR 6500f" },
	{ 205, 1, false, "SPR 4000f" },
	{ 206, 1, false, "SPR 3300f" },
	{ 207, 3, false, "Fronius IG Plus 12.0-3 WYE277" },
	{ 208, 1, false, "Fronius IG Plus 50" },
	{ 209, 1, false, "Fronius IG Plus 100" },
	{ 210, 1, false, "Fronius IG Plus 100" },
	{ 211, 1, false, "Fronius IG Plus 150" },
	{ 212, 1, false, "Fronius IG Plus 35" },
	{ 213, 1, false, "Fronius IG Plus 70" },
	{ 214, 1, false, "Fronius IG Plus 70" },
	{ 215, 1, false, "Fronius IG Plus 120" },
	{ 216, 1, false, "Fronius IG Plus 3.0-1 UNI" },
	{ 217, 1, false, "Fronius IG Plus 3.8-1 UNI" },
	{ 218, 1, false, "Fronius IG Plus 5.0-1 UNI" },
	{ 219, 1, false, "Fronius IG Plus 6.0-1 UNI" },
	{ 220, 1, false, "Fronius IG Plus 7.5-1 UNI" },
	{ 221, 1, false, "Fronius IG Plus 10.0-1 UNI" },
	{ 222, 1, false, "Fronius IG Plus 11.4-1 UNI" },
	{ 223, 3, false, "Fronius IG Plus 11.4-3 Delta" },
	{ 224, 1, false, "Fronius Galvo 3.0-1" },
	{ 225, 1, false, "Fronius Galvo 2.5-1" },
	{ 226, 1, false, "Fronius Galvo 2.0-1" },
	{ 227, 1, false, "Fronius IG 4500-LV" },
	{ 228, 1, false, "Fronius Galvo 1.5-1" },
	{ 229, 1, false, "Fronius IG 2500-LV" },
	{ 230, 3, false, "Fronius Agilo 75.0-3" },
	{ 231, 3, false, "Fronius Agilo 100.0-3 Dummy" },
	{ 232, 3,  true, "Fronius Symo 10.0-3-M" },
	{ 233, 3,  true, "Fronius Symo 12.5-3-M" },
	{ 234, 1, false, "Fronius IG 5100" },
	{ 235, 1, false, "Fronius IG 4000" },
	{ 236, 3,  true, "Fronius Symo 8.2-3-M Dummy" },
	{ 237, 1, false, "Fronius IG 3000" },
	{ 238, 1, false, "Fronius IG 2000" },
	{ 239, 1, false, "Fronius Galvo 3.1-1 Dummy" },
	{ 240, 3, false, "Fronius IG Plus 80 V-3" },
	{ 241, 3, false, "Fronius IG Plus 60 V-3" },
	{ 242, 3, false, "Fronius IG Plus 55 V-3" },
	{ 243, 1, false, "Fronius IG 60 ADV" },
	{ 244, 1, false, "Fronius IG 500" },
	{ 245, 1, false, "Fronius IG 400" },
	{ 246, 1, false, "Fronius IG 300" },
	{ 247, 3, false, "Fronius Symo 3.0-3-S" },
	{ 248, 1, false, "Fronius Galvo 3.1-1" },
	{ 249, 1, false, "Fronius IG 60 HV" },
	{ 250, 1, false, "Fronius IG 40" },
	{ 251, 1, false, "Fronius IG 30 Dummy" },
	{ 252, 1, false, "Fronius IG 30" },
	{ 253, 1, false, "Fronius IG 20" },
	{ 254, 1, false, "Fronius IG 15" },
};

static int DeviceCount = sizeof(Devices) / sizeof(Devices[0]);

static bool AreEqual(const FroniusDeviceInfo &i1, int dt) {
	return i1.deviceType < dt;
}

const FroniusDeviceInfo *FroniusDeviceInfo::find(int deviceType)
{
	const FroniusDeviceInfo *begin = Devices;
	const FroniusDeviceInfo *end = Devices + DeviceCount;
	const FroniusDeviceInfo *it =
			std::lower_bound(begin, end, deviceType, AreEqual);
	if (it == end || it->deviceType != deviceType)
		return 0;
	return it;
}
